c      subroutine seaemiss(wind,sfct,hz,ems)
       implicit none
       COMPLEX aid15,aid25,aid35,eps
       real wind,sfct,hz,angle,radus,deltax,theta,thetx,emi_der
       real wdelta,tdelta,ref,tr5,sfct1,wind1,emi_dx5,emi_lmt,g5
       real emvw,emvt,emi_fwd5,ref5,rclear5,foam5,rfoam5
       integer i
       wind = 10.
       sfct = 291.
       hz = 50.3e9 
       ANGLE = 0.0
       radus = 6370.
       deltax = 0.1
       THETx=ASIN(SIN(ANGLE)*(RADUS+870.)/RADUS)
c       wind=  sqrt(u*u+v*v)
       theta = thetx*180./3.141592654	
c       hz90 =91.655*1e9
       call refl(wind,thetx,'V',sfct,36.5,hz,eps,aid15,
     $    aid25,aid35,tr5,g5,foam5,rfoam5,rclear5,ref5,emi_fwd5)
       call refl_tlm(wind,thetx,'V',sfct,36.5,hz,ref,emvw,emvt)
      do i = 1,20 
       wdelta = deltax * wind
c       wdelta = 0.
       tdelta = deltax * sfct
c       tdelta = 0.
       wind1 = wind + wdelta
       sfct1 = sfct + tdelta 
       call refl(wind1,thetx,'V',sfct1,36.5,hz,eps,aid15,
     $    aid25,aid35,tr5,g5,foam5,rfoam5,rclear5,ref5,emi_dx5)
       emi_der = emvw * wdelta + emvt * tdelta
       emi_lmt = (emi_dx5 - emi_fwd5) / emi_der 
       write(*,123)i,deltax,tdelta,emi_dx5,emi_fwd5,emi_der,emi_lmt
123    format(i2,2e12.4,2f12.8,e13.5,f13.7)
       deltax = 0.5 * deltax
      enddo
      deltax = 0.1
      do i = 1,20 
       wdelta = deltax * wind
c       wdelta = 0.
       tdelta = deltax * sfct
c       tdelta = 0.
       wind1 = wind - wdelta
       sfct1 = sfct - tdelta 
       call refl(wind1,thetx,'V',sfct1,36.5,hz,eps,aid15,
     $    aid25,aid35,tr5,g5,foam5,rfoam5,rclear5,ref5,emi_dx5)
       emi_der = emvw * wdelta + emvt * tdelta
       emi_lmt = (emi_dx5 - emi_fwd5) / emi_der 
       write(*,123)i,deltax,tdelta,emi_dx5,emi_fwd5,emi_der,emi_lmt
       deltax = 0.5 * deltax
      enddo
       stop
       end
      SUBROUTINE REFL_TLM(WIND,ANGLE,POLAR,T,S,F,
     $         REF_TL,EMI_TLW,EMI_TLT)
      IMPLICIT NONE
      REAL ANGLE,WIND,LAMBDA,LAMBDAS,TC,T,S,F,AID2_ABS,AID3_ABS
      REAL GAMMA_TLW,GAMMA_TLT,RFOAM_TL,REF_TL,EMI_TLW,EMI_TLT
      REAL FOAM_TL,RCLEAR_TLW,RCLEAR_TLT,TR_TL,REF5,EMI5,TR5
      REAL EPSP5,EPSPP5,G5,RCLEAR5,FOAM5,PI,RFOAM5,DEGRE
      REAL EPSP50,EPSPP50, EPSPP501,EPSPP51,a2,b2,a3,b3 
      real aid1i,aid1r,aid1r1,aid1i1,r2,i2,r3,i3
      real td,tm1,tm2,tm3,tm4,tm5,tm6,tm7,tm11,tm12,tm
      real amp2,amp3,damp2,damp3
      CHARACTER POLAR 
      COMPLEX MU,EPS5,EPS1,AID15,AID25,AID35,CANG,AID1,d
      COMPLEX AID1_TL,AID2_TL,AID3_TL,EPS_TL,aid11,aid12
      MU = CMPLX (1.0,0.0)

      CALL EPSP_TLM(T,S,F,EPSP50,EPSP5)
      CALL EPSPP_TLM(T,S,F,EPSPP501,EPSPP51)
c      write(*,*)'relf_tlm epsp epspp =',epsp50,epspp50
      CALL REFL(WIND,ANGLE,POLAR,T,S,F,EPS5,
     $   AID15,AID25,AID35,TR5,G5,FOAM5,RFOAM5,RCLEAR5,
     $   REF5,EMI5) 
C* COMPLEX DIELECTRIC PROPERTIES OF SALINE WATER
      EPSPP5 = -1.*EPSPP51
      EPSPP50 = -1.*EPSPP501
c      EPS_TL=CMPLX (EPSP5,-EPSPP5)
      EPS_TL=CMPLX (EPSP5,EPSPP5)
      write(*,*)epspp51,eps_tl

C* COMPLEX REFRACTIVE INDEX OF SALINE WATER (NOT USED)
c
c      REFWAT = CSQRT(EPS)
     
      CANG=CMPLX(ANGLE,0.)
      PI = 4.0*ATAN(1.0)
      DEGRE = ANGLE/PI*180.0
      eps1 = cmplx(epsp50,epspp50)
      write(*,*)' eps5= ', eps5
      write(*,*)' eps1 = ',eps1
      d = cmplx(0,-1)
      AID1_TL=0.5*MU*EPS_TL/AID15
c      XR = AID1_TL
c      XI = AID1_TL * d
c      AID1 = CSQRT(MU*EPS-CSIN(CANG)**2)
c      write(*,*)'main aid1 = ', aid1
      write(*,*)'main aid15 = ', aid15
      write(*,*)'main aid1_tl = ', aid1_tl

      IF (POLAR.EQ.'H') THEN
c                AID2 = MU*CCOS(CANG)-AID1
c                AID3 = MU*CCOS(CANG)+AID1
                AID2_TL = -AID1_TL
                AID3_TL = AID1_TL
C* EMPERICAL FUNCTIONS FOR WIND INDUCED REFLECTION CHANGES
c                G = 1.0 - 1.748E-3*DEGRE-7.336E-5*DEGRE**2+
c     &              1.044E-7*DEGRE**3
c                TR = WIND*(1.15E-1+3.8E-5*DEGRE**2)*SQRT(F*1.0E-9)
                TR_TL = (1.15E-1+3.8E-5*DEGRE**2)*SQRT(F*1.0E-9)
      ELSE
c                AID2 = EPS*CCOS(CANG)-AID1
c                AID3 = EPS*CCOS(CANG)+AID1 
                AID2_TL = EPS_TL*CCOS(CANG) - AID1_TL
                AID3_TL = EPS_TL*CCOS(CANG) + AID1_TL
C* EMPERICAL FUNCTIONS FOR WIND INDUCED REFLECTION CHANGES
c                G = 1.0 - 9.946E-4*DEGRE+3.218E-5*DEGRE**2
c     &              -1.187E-6*DEGRE**3+7.E-20*DEGRE**10
c                TR = WIND*(1.17E-1-2.09E-3*EXP(7.32E-2*DEGRE))
c     &              *SQRT(F*1.0E-9)
                TR_TL = (1.17E-1-2.09E-3*EXP(7.32E-2*DEGRE))
     &              *SQRT(F*1.0E-9)
      ENDIF

      a2 = aid2_tl
      b2 = aid2_tl*d
      a3 = aid3_tl
      b3 = aid3_tl*d
      r2 = aid25
      i2 = aid25*d
      r3 = aid35
      i3 = aid35*d
      amp2 = r2*r2 + i2*i2
      amp3 = r3*r3 + i3*i3
      damp2 = 2.*(r2*a2 + i2*b2)
      damp3 = 2.*(r3*a3 + i3*b3)
      REF_TL = damp2 / amp3 - amp2 * damp3 / amp3**2

c      write(*,*)' aid25 = ',aid25
c      write(*,*)' aid2_tl = ',aid2_tl
c      write(*,*)' aid35 = ',aid35
c      write(*,*)' aid35 = ',r3,i3
c      write(*,*)' aid3_tl = ',aid3_tl
c      write(*,*)' r2,i2 = ',r2,i2
c      write(*,*)' a2, b2 ',a2,b2
c      write(*,*)' r3,i3 = ',r3,i3
c      write(*,*)' a3, b3 ',a3,b3
c      td = r3*r3 + i3*i3
c      write(*,*)' td ',td
c      tm1 = r2*r3 + i2*i3
c      write(*,*)' tm1 ',tm1
c      tm2 = i2*r3 - r2*i3
c      write(*,*)' tm2 ',tm2
c      tm3 = tm1*tm1 + tm2*tm2
c      write(*,*)' tm3 ',tm3
c      tm4 = sqrt(tm3)
c      write(*,*)' tm4 ',tm4
c      tm5 = a2*r3+r2*a3+b2*i3+i2*b3
c      write(*,*)' tm5 ',tm5
c      tm6 = b2*r3+i2*a3-a2*i3-r2*b3
c      write(*,*)' tm6 ',tm6
c      tm7 = r3*a3+i3*b3
c      write(*,*)' tm7 ',tm7
c      tm11 = (tm1*tm5 + tm2*tm6) / (td*tm4)
c      write(*,*)' tm11 ',tm11
c      tm12 = 2.*tm4*tm7/(td*td)
c      write(*,*)' tm12 ',tm12
c      tm = tm11 - tm12
c      write(*,*)' tm ',tm
c      REF_TL = tm * tm
c      write(*,*)' REF_TL ',REF_TL

c      CALL AID2_TLM(EPSP50,EPSP5,EPSPP50,EPSPP5,ANGLE,
c     $   AID15,AID1_TL,AID2_ABS,
c     $   aid1r,aid1i)
c      aid11 = cmplx(aid1r,aid1i)
c      CALL AID3_TLM(EPSP50,EPSP5,EPSPP50,EPSPP5,ANGLE,
c     $   AID15,AID1_TL,AID3_ABS,
c     $   aid1r1,aid1i1)
c      aid12 = cmplx(aid1r1,aid1i1)
c      write(*,*)'aid1_tl= ',aid15,aid11
c      write(*,*)'aid1_tl= ',aid15,aid12
c      REF = ( CABS(AID2/AID3) )**2
c      REF_TL = 2.* (AID2_ABS*CABS(AID35)**2 - CABS(AID25)**2
c     $     *AID3_ABS) / CABS(AID35)**4
c       REF_TL = CABS(AID25/AID35)*2.*CABS((AID2_TL*AID35 -
c     $      AID25*AID3_TL)/AID35**2)
      IF(WIND.LT.7.0) THEN
c         FOAM=0.0
         FOAM_TL=0.0
      ELSE
c         FOAM=0.006*(1.0-EXP(-F*1.0E-9/7.5))*(WIND-7.0)
         FOAM_TL=0.006*(1.0-EXP(-F*1.0E-9/7.5))
      ENDIF 
C CORRECTION FOR WIND INDUCED FOAM FREE SEA SURFACE
c      RCLEAR = REF - TR/T
      RCLEAR_TLW = - TR_TL/T
      RCLEAR_TLT = REF_TL + TR5/(T**2)
C* REFLECTION COEFFICIENT FOR FOAM COVERED SEA
c      RFOAM = 1.0-(208.0+1.29E-9*F)/T*G 
      RFOAM_TL = (208.0+1.29E-9*F)/(T**2)*G5 
C* MOW LINEAR INTERPOLATION BETWEEN FOAM FREE AND FOAM COVERED
c      GAMMA = (1.0-FOAM)*RCLEAR+FOAM*RFOAM
      GAMMA_TLW = -FOAM_TL*RCLEAR5 + (1.0-FOAM5)*RCLEAR_TLW 
     $        + FOAM_TL*RFOAM5
      GAMMA_TLT = (1.0-FOAM5)*RCLEAR_TLT+FOAM5*RFOAM_TL
c      EMI = 1.0 - GAMMA
      EMI_TLW = -GAMMA_TLW
      EMI_TLT = -GAMMA_TLT
      RETURN
      END
      subroutine aid2_tlm(epsp,epsp_tl,epspp1,epspp_tl,ang,
     $         aid1,aid1_tl,aid2_abs,
     &         aid1r,aid1i)
      implicit none
      real aid11r,aid11i,ad1,ad2,aid1r,aid1i
      real epsp,epsp_tl,epspp,epspp_tl,ang,aid2_abs,c1,c2
      real epsr,epsa,epsp2,epsa_tl,epsr_tl,epsr1,epspp1
      complex aid1,aid1_tl,d
      real  ar,ai,ar_tl,ai_tl

      d = cmplx(0,-1)
      ar = aid1
      ai = aid1*d
c      write(*,*)'sub a = ', cmplx(ar,ai)
      ar_tl = aid1_tl
      ai_tl = aid1_tl*d
c      write(*,*)'sub1 a = ', cmplx(ar_tl,ai_tl)
      epspp = epspp1
c      write(*,*)'aid2_tlm ',epsp,epspp
      c1 = cos(ang)
      c2 = sin(ang) * sin(ang)
      epsp2 = epsp - c2
c      write(*,*)' the next 4 lines from subr aid2_tlm '
c      write(*,*)' epsp**2 = ', epsp2*epsp2
c      write(*,*)' epspp**2 = ', epspp*epspp
c      write(*,*)' epsa ', epsa
      epsa =  (epsp2*epsp2 + epspp*epspp)**0.25
c      write(*,*)epsa
      epsr1 = 0.5 * atan(epspp/epsp2)*180./3.1415926
      epsr = 0.5 * atan(epspp/epsp2)
c      write(*,*)' sqrt angle ', epsr1
      aid11r = epsa*cos(epsr)
      aid11i = epsa*sin(epsr)
c      write(*,*)' sub aid1 ',cmplx(aid11r,aid11i)

      epsa_tl=0.5/epsa**3*(epsp2*epsp_tl+epspp*epspp_tl)
      epsr_tl=0.5/epsa**4*(epspp_tl*epsp2+epspp*epsp_tl)
      ad1 = epsa_tl*cos(epsr) - epsa*sin(epsr)*epsr_tl
      ad2 = epsa_tl*sin(epsr) + epsa*cos(epsr)*epsr_tl
c      write(*,*)' subr aid1_tl = ',cmplx(ad1,ad2)
c      aid2_abs = 2. * ((c1*epsp - epsa*cos(epsr))*(c1*epsp_tl- 
c     *       epsa_tl*cos(epsr) + epsa*sin(epsr)*epsr_tl) +
c     *       (c1*epspp - epsa*sin(epsr)) * 
c     *       (c1*epspp_tl - epsa_tl*sin(epsr)-epsa*cos(epsr)*epsr_tl))
      aid2_abs = (c1*epsp - ar)*(c1*epsp_tl - ar_tl) +
     $       (c1*epspp-ai)*(c1*epspp - ai_tl)
      return
      end
      subroutine aid3_tlm(epsp,epsp_tl,epspp1,epspp_tl,ang,
     &         aid1,aid1_tl,aid3_abs,
     &         aid1r,aid1i)
      implicit none
      real aid1r,aid1i,ad1,ad2
      real epsp,epsp_tl,epspp,epspp_tl,ang,aid3_abs,c1,c2
      real epsr,epsa,epsp2,epsa_tl,epsr_tl,epspp1
      complex aid1,aid1_tl,d
      real  ar,ai,ar_tl,ai_tl

      d = cmplx(0,-1)
      ar = aid1
      ai = aid1*d
c      write(*,*)'sub a = ', cmplx(ar,ai)
      ar_tl = aid1_tl
      ai_tl = aid1_tl*d
c      write(*,*)'sub a2 = ', cmplx(ar_tl,ai_tl)
      c1 = cos(ang)
      epspp = epspp1
      c2 = sin(ang) * sin(ang)
      epsp2 = epsp - c2
      epsa = (epsp2*epsp2 + epspp*epspp)**0.25
      epsr = 0.5 * atan(epspp/epsp2)
c      write(*,*)epspp,epsa,epsr,' epsp2 = ',epsp2
      aid1r = epsa*cos(epsr)
      aid1i = epsa*sin(epsr)
      write(*,*)' second = ', aid1r,aid1i
      
      epsa_tl = 0.5 / epsa**3 * (epsp2*epsp_tl + epspp*epspp_tl)
      epsr_tl = 0.5 / epsa**4 * (epspp_tl*epsp2 + epspp*epsp_tl)
      ad1 = epsa_tl*cos(epsr) - epsa*sin(epsr)*epsr_tl
      ad2 = epsa_tl*sin(epsr) + epsa*cos(epsr)*epsr_tl
      write(*,*)' subr2 aid1_tl = ',cmplx(ad1,ad2)
c      aid3_abs = 2. * ((c1*epsp + epsa*cos(epsr)) * (c1*epsp_tl + 
c     *       epsa_tl*cos(epsr) - epsa*sin(epsr)*epsr_tl) +
c     *       (c1*epspp + epsa*sin(epsr)) * 
c     *       (c1*epspp_tl+epsa_tl*sin(epsr)+epsa*cos(epsr)*epsr_tl))
      aid3_abs = (c1*epsp + ar)*(c1*epsp_tl + ar_tl) +
     $       (c1*epspp+ai)*(c1*epspp + ai_tl)
      return
      end
      SUBROUTINE REFL (WIND,ANGLE,POLAR,T,S,F,eps,
     $        AID1,AID2,AID3,TR,G,
     $        FOAM,RFOAM,RCLEAR,REF,EMI)
C
C THIS FUNCTION CALCULATES THE EMISSIVITY OF A FLAT SURFACE
C REF: MICROWAVE REMOTE SENSING ACTIVE AND PASSIVE
C BY ULABY, MOORE AND FUNG.
C PAG. 230
C VARIABLES: ANGLE = DIRECTION ANGLE IN RADIANS
C            DEGRE = DIRECTION ANGLE IN DEGREES
C            POLAR = POLARIZATION
C            T     = TEMPERATURE
C            S     = SEA WATER SALINITY
C            F     = FREQUENCY
C            WIND  = WIND SPEED
C            FOAM  = FOAM FRACTION
C            G,TR  = EMPIRICAL FUNCTIONS FOR WIND INDUCED 
C                    CHANGES IN REFLECTION COEFFICIENT
C NOTE THAT MU AND EPS ARE COMPLEX QUANTITIES
C-------------------------------------------------------------------
      REAL ANGLE,WIND,LAMBDA,LAMBDAS,TC
      CHARACTER POLAR
      COMPLEX MU, EPS, AID1,AID2,AID3,CANG,REFWAT
      MU = CMPLX (1.0,0.0)

      CALL EPSP(T,S,F,A5,B5,ESWI5,ESWO5,ESW5,TSWO5,TSW5,EPSP5)
      CALL EPSPP(T,S,F,ESWI5,EO5,PI5,SSWO5,ESWO5,A5,ESW5,TSWO5,
     $   B5,TSW5,FI5,EPSPP5)
C* COMPLEX DIELECTRIC PROPERTIES OF SALINE WATER
      EPS=CMPLX (EPSP5,-EPSPP5)
C* COMPLEX REFRACTIVE INDEX OF SALINE WATER (NOT USED)
      REFWAT = CSQRT(EPS)
     
      CANG=CMPLX(ANGLE,0.)
      PI = 4.0*ATAN(1.0)
      DEGRE = ANGLE/PI*180.0
      AID1=CSQRT(MU*EPS-CSIN(CANG)**2)
      IF (POLAR.EQ.'H') THEN
                AID2 = MU*CCOS(CANG)-AID1
                AID3 = MU*CCOS(CANG)+AID1
C* EMPERICAL FUNCTIONS FOR WIND INDUCED REFLECTION CHANGES
                G = 1.0 - 1.748E-3*DEGRE-7.336E-5*DEGRE**2+
     &              1.044E-7*DEGRE**3
                TR = WIND*(1.15E-1+3.8E-5*DEGRE**2)*SQRT(F*1.0E-9)
      ELSE
                AID2 = EPS*CCOS(CANG)-AID1
                AID3 = EPS*CCOS(CANG)+AID1 
C* EMPERICAL FUNCTIONS FOR WIND INDUCED REFLECTION CHANGES
                G = 1.0 - 9.946E-4*DEGRE+3.218E-5*DEGRE**2
     &              -1.187E-6*DEGRE**3+7.E-20*DEGRE**10
                TR = WIND*(1.17E-1-2.09E-3*EXP(7.32E-2*DEGRE))
     &              *SQRT(F*1.0E-9)
      ENDIF
      REF = ( CABS(AID2/AID3) )**2
C* THE REFLECTION OF A SPECULAR CALM SEA WITH 
C* WIND INDUCED CHANGES IN THE SURFACE REFLECTION
C* SOURCE: FRANCIS ET AL. 1983 IN 
C*         SATELLITE MICROWAVE REMOTE SENSING
C*         ED BY ALLAN
C*         AND OBSERVATIONS BY HOLLINGER (1971) AND STROGRYN (1971)
C
C* FOAM FRACTION
C      B0 =  1.707E-2+8.560E-4*(F*1.0E-9)+1.120E-5*(F*1.0E-9)**2
C      B1 = -1.501E-2+1.821E-3*(F*1.0E-9)-4.634E-5*(F*1.0E-9)**2
C      B2 =  2.442E-4-2.282E-6*(F*1.0E-9)+4.194E-7*(F*1.0E-9)**2
C      FOAM = B0+B1*WIND+B2*WIND**2
      IF(WIND.LT.7.0) THEN
         FOAM=0.0
      ELSE
         FOAM=0.006*(1.0-EXP(-F*1.0E-9/7.5))*(WIND-7.0)
      ENDIF 
C CORRECTION FOR WIND INDUCED FOAM FREE SEA SURFACE
      IF(FOAM.LT.0.) FOAM=0. 
      IF(FOAM.GT.1.) FOAM=1.  
      RCLEAR = REF - TR/T
C* REFLECTION COEFFICIENT FOR FOAM COVERED SEA
      RFOAM = 1.0-(208.0+1.29E-9*F)/T*G 
C* MOW LINEAR INTERPOLATION BETWEEN FOAM FREE AND FOAM COVERED
      GAMMA = (1.0-FOAM)*RCLEAR+FOAM*RFOAM
      EMI = 1.0 - GAMMA
      IF(EMI.GT.1.0) EMI=1.0       
      IF(EMI.LT.0.0) EMI=0.0       
      RETURN
      END

      SUBROUTINE EPSP_TLM(T1,S,F,EPSP5,epsp_tl)

      T=T1-273.0
      T2=(T-25.0)
c      ESWI = 4.9
    
         CALL EPSP(T1,S,F,A5,B5,ESWI5,ESWO5,ESW5,
     *         TSWO5,TSW5,EPSP5)
c      ESWO = 87.134-1.949E-1*T-1.276E-2*T*T+2.491E-4*T**3
c      write(*,*)'ESWO5 - ESWO ', ESWO5 - ESWO
      eswo_tl = -1.949E-1 - 2.*1.276E-2*T + 3.*2.491E-4*T*T 
c      A = 1.0+1.613E-5*T*S-3.656E-3*S+3.210E-5*S*S-4.232E-7*S**3
      a_tl = 1.613E-5*S
c      ESW = ESWO*A
      esw_tl = eswo_tl * A5 + ESWO5 * a_tl

c      TSWO = 1.1109E-10-3.824E-12*T+6.938E-14*T**2-5.096E-16*T**3
      tswo_tl = -3.824E-12 + 2.*6.938E-14*T - 3.*5.096E-16*T*T
c      B = 1.0+2.282E-5*T*S-7.638E-4*S-7.760E-6*S**2+1.105E-8*S**3
      b_tl = 2.282E-5*S
c      TSW = TSWO*B
      tsw_tl = tswo_tl * B5 + TSWO5 * b_tl

c      EPSP = ESWI +(ESW-ESWI)/(1.0+(F*TSW)**2)
      epsp1 = (1.0+(F*TSW5)**2)**2
      epsp_tl = esw_tl * (1.0+(F*TSW5)**2) - 2.*(ESW5-ESWI5)*F*F
     $  *TSW5*tsw_tl
      epsp_tl = epsp_tl / epsp1 
     
      RETURN
      END
      SUBROUTINE EPSP (T1,S,F,A,B,ESWI,ESWO,ESW,TSWO,TSW,EPSP2)
C
C THIS FUNCTION CALCULATES THE REAL PART OF THE DIELECTRIC CONSTANT
C FOR SALINE WATER
C
C SOURCE : MICROWAVE REMOTE SENSING PAG 2022
C UNITS:
C TEMPERATURE (T) IS IN DEGREES CELSIUS
C SALINITY (S) PARTS PER THOUSAND
C FREQUENCY (F) HZ

      T=T1-273.0
      T2=(T-25.0)
      ESWI = 4.9
    
      ESWO = 87.134-1.949E-1*T-1.276E-2*T*T+2.491E-4*T**3
      A = 1.0+1.613E-5*T*S-3.656E-3*S+3.210E-5*S*S-4.232E-7*S**3
      ESW = ESWO*A

      TSWO = 1.1109E-10-3.824E-12*T+6.938E-14*T**2-5.096E-16*T**3
      B = 1.0+2.282E-5*T*S-7.638E-4*S-7.760E-6*S**2+1.105E-8*S**3
      TSW = TSWO*B

      EPSP2 = ESWI +(ESW-ESWI)/(1.0+(F*TSW)**2)
     
      RETURN
      END

      SUBROUTINE EPSPP_TLM(T1,S,F,EPSPP5,EPSPP_TL)

      T=T1-273.0
c      T2=T-25.0
c      ESWI = 4.9
c      EO = 8.854E-12
c      PI = 4.0 * ATAN(1.0)
      CALL EPSPP(T1,S,F,ESWI5,EO5,PI5,SSWO5,ESWO5,A5,ESW5,
     $    TSWO5,B5,TSW5,FI5,EPSPP5)
      eswo_tl = -1.949E-1 - 2.*1.276E-2*T + 3.*2.491E-4*T*T
      a_tl = 1.613E-5*S
      esw_tl = eswo_tl * A5 + ESWO5 * a_tl
      tswo_tl = -3.824E-12 + 2.*6.938E-14*T - 3.*5.096E-16*T*T
      b_tl = 2.282E-5*S
      tsw_tl = tswo_tl * B5 + TSWO5 * b_tl
      D = 25.0-T
c      d_tl = -1.
c      FI = D*(2.033E-2+1.266E-4*D+2.464E-6*D**2-
c     &       S*(1.849E-5-2.551E-7*D+2.551E-8*D*D))
      fi_tl = -1.*(2.033E-2+1.266E-4*D+2.464E-6*D**2-
     &       S*(1.849E-5-2.551E-7*D+2.551E-8*D*D))
     &      +D*(-1.266E-4-2.*2.464E-6*D 
     &      -S*(2.551E-7-2.*2.551E-8*D))
c      SSW = SSWO*EXP(-FI)
      ssw_tl = -sswo5*fi_tl*exp(-fi5)
c      EPSPP = TSW*F*(ESW-ESWI)/(1.0+(TSW*F)**2)
c      EPSPP = EPSPP + SSW/(2.0*PI*EO*F)
      epspp1 = (1.0+(F*TSW5)**2)**2
      epspp_tl = (esw_tl * (1.0+(F*TSW5)**2) - 2.*(ESW5-ESWI5)*F*F
     $  *TSW5*tsw_tl)*tsw5*f/epspp1 + f*tsw_tl*
     $  (ESW5-ESWI5)/(1.0+(TSW5*F)**2) 
      epspp_tl = epspp_tl + ssw_tl/(2.*PI5*EO5*F) 
c      epspp_tl = epspp_tl * tperc
      RETURN
      END
      SUBROUTINE EPSPP(T1,S,F,ESWI,EO,PI,SSWO,ESWO,A,ESW,
     $    TSWO,B,TSW,FI,EPSPP2)
C
C-------------------------------------------------------------------
C
C THIS FUNCTION CALCULATES THE IMAGINAIR PART OF THE DIELECTRIC CONSTANT
C FOR SALINE WATER
C
C SOURCE : MICROWAVE REMOTE SENSING PAG 2022
C NOTE THAT THE TEMPERATURE (T) IS IN DEGREES CELSIUS
C SALINITY (S) PARTS PER THOUSAND

      T=T1-273.0
      T2=T-25.0
      ESWI = 4.9
      EO = 8.854E-12
      PI = 4.0 * ATAN(1.0)
      ESWO = 87.134-1.949E-1*T-1.276E-2*T*T+2.491E-4*T**3
      A = 1.0+1.613E-5*T*S-3.656E-3*S+3.210E-5*S*S-4.232E-7*S**3
      ESW = ESWO*A
      TSWO = 1.1109E-10-3.824E-12*T+6.938E-14*T**2-5.096E-16*T**3
      B = 1.0+2.282E-5*T*S-7.638E-4*S-7.760E-6*S**2+1.105E-8*S**3
      TSW = TSWO*B
      SSWO = S*(0.18252-1.4619E-3*S+2.093E-5*S**2-1.282E-7*S**3)
      D = 25.0-T
      FI = D*(2.033E-2+1.266E-4*D+2.464E-6*D**2-
     &       S*(1.849E-5-2.551E-7*D+2.551E-8*D*D))
      SSW = SSWO*EXP(-FI)
      EPSPP2 = TSW*F*(ESW-ESWI)/(1.0+(TSW*F)**2)
      EPSPP2 = EPSPP2 + SSW/(2.0*PI*EO*F)
      RETURN
      END

